import { InputPublisherModel, InputRequisitionModel, InputSubscriptionModel } from 'enqueuer';
export interface EnqueuerStep {
    step?: InputRequisitionModel | InputSubscriptionModel | InputPublisherModel;
    variables?: {
        [key: string]: any;
    };
}
export declare class EnqueuerData {
    private requisitionsCache;
    private publishersCache;
    private subscriptionsCache;
    private groupsCache;
    private requisitionFileParser;
    private cucumberMatcher;
    private debugger;
    constructor();
    initEnqueuer(): void;
    getRequisitions(): InputRequisitionModel[];
    getRequisitionNames(): string[];
    getPublishers(): InputPublisherModel[];
    getPublisherNames(): string[];
    getSubscriptions(): InputSubscriptionModel[];
    getSubscriptionNames(): string[];
    getGroups(): InputRequisitionModel[];
    getGroupNames(): string[];
    getRequisitionStep(name: string, createIfNotExist?: boolean): EnqueuerStep;
    getPublisherStep(name: string): EnqueuerStep;
    getSubscriptionStep(name: string): EnqueuerStep;
    getGroupStep(name: string): EnqueuerStep;
    getDefaultRequisition(name: string): any;
    private mergeStepVariables;
    private buildRequisitionsCache;
    private cloneStep;
}
