'use strict';
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var cucumber_1 = require("cucumber");
var debug_1 = require("debug");
var _ = require("lodash");
var enqueuer_1 = require("enqueuer");
var cucumber_steps_1 = require("./cucumber-steps");
var enqueuer_data_1 = require("./enqueuer-data");
debug_1.default.formatters.J = function (v) {
    return JSON.stringify(v, null, 2);
};
var MAIN_REQUISITION = 'Cucumber_Main_requisition';
var EnqueuerStepDefinitions = /** @class */ (function () {
    function EnqueuerStepDefinitions() {
        this.debugger = debug_1.default('EnqueuerCucumber');
        this.enquererData = new enqueuer_data_1.EnqueuerData();
        this.cucumberStepsBuilder = new cucumber_steps_1.CucumberStepsBuilder();
    }
    EnqueuerStepDefinitions.prototype.build = function () {
        this.debugger('Starting EnqueuerStepDefinitions plugin');
        this.enquererData.initEnqueuer();
        this.buildBeforeHook();
        this.buildSteps();
    };
    EnqueuerStepDefinitions.prototype.buildBeforeHook = function () {
        var self = this;
        cucumber_1.Before(function (testcase) {
            return __awaiter(this, void 0, void 0, function () {
                var requisition, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            requisition = self.buildEnqueuerRequisition(testcase);
                            if (!requisition) return [3 /*break*/, 2];
                            _a = this;
                            return [4 /*yield*/, self.executeEnqueuer(requisition)];
                        case 1:
                            _a.testReport = _b.sent();
                            _b.label = 2;
                        case 2: return [2 /*return*/];
                    }
                });
            });
        });
    };
    EnqueuerStepDefinitions.prototype.buildSteps = function () {
        var _this = this;
        this.enquererData.getRequisitions().forEach(function (requisition) {
            _this.cucumberStepsBuilder.createGivenStep(requisition);
        });
        this.enquererData.getPublishers().forEach(function (publisher) {
            _this.cucumberStepsBuilder.createWhenStep(publisher);
        });
        this.enquererData.getSubscriptions().forEach(function (subscription) {
            _this.cucumberStepsBuilder.createThenStep(subscription);
        });
        this.enquererData.getGroups().forEach(function (group) {
            _this.cucumberStepsBuilder.createGroupStep(group);
        });
    };
    EnqueuerStepDefinitions.prototype.executeEnqueuer = function (requisition) {
        return __awaiter(this, void 0, void 0, function () {
            var finalReports;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.debugger('Executing requisition <<%s>> in Enqueuer', requisition.name);
                        return [4 /*yield*/, new enqueuer_1.RequisitionRunner(requisition).run()];
                    case 1:
                        finalReports = _a.sent();
                        this.debugger('Report execution for requisition <<%s>>: %J', requisition.name, finalReports);
                        return [2 /*return*/, finalReports];
                }
            });
        });
    };
    EnqueuerStepDefinitions.prototype.buildEnqueuerRequisition = function (testcase) {
        var _this = this;
        this.debugger('Building enqueuer requisition for test execution: <<%s>>', testcase.pickle.name);
        this.debugger('Cucumber metadata for test: %J', testcase);
        var requisitionStep = this.enquererData.getRequisitionStep(testcase.pickle.name, true);
        var requisition = this.fromEnqueuerStep(requisitionStep.step, requisitionStep);
        requisition = _.defaultsDeep(requisition, { onInit: { store: {} } });
        testcase.pickle.steps.forEach(function (step) {
            var innerRequisition = _this.enquererData.getRequisitionStep(step.text);
            var stepMatched = false;
            if (innerRequisition.step) {
                requisition.requisitions.push(_this.fromEnqueuerStep(requisition, innerRequisition));
                stepMatched = true;
            }
            if (!stepMatched) {
                var publisher = _this.enquererData.getPublisherStep(step.text);
                if (publisher.step) {
                    var mainRequisition = _this.getMainRequisition(requisition);
                    mainRequisition.publishers.push(_this.fromEnqueuerStep(requisition, publisher));
                    stepMatched = true;
                }
            }
            if (!stepMatched) {
                var subscription = _this.enquererData.getSubscriptionStep(step.text);
                if (subscription.step) {
                    var mainRequisition = _this.getMainRequisition(requisition);
                    mainRequisition.subscriptions.push(_this.fromEnqueuerStep(requisition, subscription));
                    stepMatched = true;
                }
            }
            if (!stepMatched) {
                _this.buildEnqueuerGroup(requisition, step.text);
            }
        });
        this.debugger('Enqueuer requisition created: %J', requisition);
        return requisition;
    };
    EnqueuerStepDefinitions.prototype.buildEnqueuerGroup = function (requisition, name) {
        var group = this.enquererData.getGroupStep(name);
        if (group.step) {
            this.processEnqueuerGroup(requisition, group);
        }
    };
    EnqueuerStepDefinitions.prototype.processEnqueuerGroup = function (requisition, group) {
        var _this = this;
        var req = this.fromEnqueuerStep(requisition, group);
        var mainRequisition = this.getMainRequisition(requisition);
        if (req.requisitions) {
            req.requisitions.forEach(function (r) { return requisition.requisitions.push(r); });
        }
        if (req.publishers) {
            req.publishers.forEach(function (p) { return mainRequisition.publishers.push(p); });
        }
        if (req.subscriptions) {
            req.subscriptions.forEach(function (s) { return mainRequisition.subscriptions.push(s); });
        }
        if (req.useGroup) {
            _.castArray(req.useGroup).forEach(function (usegroup) {
                _this.buildEnqueuerGroup(requisition, usegroup);
            });
        }
        this.applyGroupTimeout(req);
    };
    EnqueuerStepDefinitions.prototype.applyGroupTimeout = function (group) {
        if (group.timeout) {
            if (group.requisitions) {
                group.requisitions.forEach(function (r) { return r.timeout = group.timeout; });
            }
            if (group.publishers) {
                group.publishers.forEach(function (p) { return p.timeout = group.timeout; });
            }
            if (group.subscriptions) {
                group.subscriptions.forEach(function (s) { return s.timeout = group.timeout; });
            }
        }
    };
    EnqueuerStepDefinitions.prototype.fromEnqueuerStep = function (requisition, requisitionStep) {
        if (requisitionStep.variables) {
            requisition.onInit.store = _.merge(requisition.onInit.store, requisitionStep.variables);
        }
        return requisitionStep.step;
    };
    EnqueuerStepDefinitions.prototype.getMainRequisition = function (requisition) {
        var mainRequisition = requisition.requisitions.find(function (req) { return req.name === MAIN_REQUISITION; });
        if (!mainRequisition) {
            mainRequisition = this.enquererData.getDefaultRequisition(MAIN_REQUISITION);
            if (requisition.timeout) {
                mainRequisition.timeout = requisition.timeout;
            }
            requisition.requisitions.push(mainRequisition);
        }
        return mainRequisition;
    };
    return EnqueuerStepDefinitions;
}());
exports.EnqueuerStepDefinitions = EnqueuerStepDefinitions;
//# sourceMappingURL=index.js.map